# Modified from NeHe tutorial 10
# => tp. RICM3 Visualisation-Multiresolution


from OpenGL.GLUT import *    	# Module For The GLUT Library
from OpenGL.GL import *		# Module For The OpenGL32 Library
from OpenGL.GLU import *	# Module For The GLu32 Library
import time     		# Module for sleeping.
from math import *    		# Module for trigonometric functions.
import sys			
import Image			#Image Loading

# ascii codes for various special keys
ESCAPE = 27
PAGE_UP = 73
PAGE_DOWN = 81
UP_ARROW = 72
DOWN_ARROW = 80
LEFT_ARROW = 75
RIGHT_ARROW = 77


presse = 1
presse_d = 1
angle_x = 0.0
angle_y = 0.0
xx = 0
yy = 0
xxold = 0
yyold = 0
zoom = -5



# The number of our GLUT window
window = None

class sommet:
    def __init__(self,_x=0,_y=0,_z=0):
        self.x = [_x,_y,_z]

class tri:
    def __init__(self,_i0=0,_i1=0,_i2=0):
        self.index = [_i0,_i1,_i2]

class mesh:
    def __init__(self):
        self.geometry=[]
        self.connectivity=[]

maillage = mesh();
        


# helper for Reading.  reads a file into a string until a nonblank, non-comment line
# is found ("#" at the start indicating a comment); assumes lines < 255 characters long.
def readstr(f):

    string = ''
    while 1:
	string = f.readline() # read the line
	#print string
        if((string[0] == '#') or (string[0] == '\n')):
        	continue
        else:
        	break
    return string

# A general OpenGL initialization function.  Sets all of the initial parameters.
def InitGL(Width, Height):	# We call this right after our OpenGL window is created.


    glBlendFunc(GL_SRC_ALPHA, GL_ONE)          # Set the blending function for translucency (note off at init time)
    glClearColor(0.0, 0.0, 0.0, 0.0)	# This Will Clear The Background Color To Black
    glClearDepth(1.0)				# Enables Clearing Of The Depth Buffer
    glDepthFunc(GL_LESS)                       # type of depth test to do.
    glEnable(GL_DEPTH_TEST)                    # enables depth testing.
    glShadeModel(GL_SMOOTH)			# Enables Smooth Color Shading

    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()				# Reset The Projection Matrix

    gluPerspective(45.0,Width/Height,0.1,100.0)	# Calculate The Aspect Ratio Of The Window

    glMatrixMode(GL_MODELVIEW)

    #light
    light_ambient=[0.4,0.4,0.4,1.0]
    light_diffuse=[0.4,0.4,0.4,1.0]
    light_specular=[1.0,1.0,1.0,1.0]
    light_position = [2.0,100.0,100.0,1.0]
    
    material_ambient = [1.0,1.0,1.0,1.0]
    material_diffuse = [1.0,1.0,1.0,1.0]
    material_specular = [1.0,1.0,1.0,1.0]
    material_exponent = [60.0]
    
    glFrontFace(GL_CCW)
    glEnable(GL_COLOR_MATERIAL)
    glShadeModel(GL_SMOOTH)
    glEnable(GL_LIGHTING)
    glEnable(GL_LIGHT0)
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE)
    glLightfv(GL_LIGHT0, GL_POSITION, light_position)
    glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient)
    glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse)
    glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular)
    
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, material_ambient)
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, material_diffuse)  
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular)  
    glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, material_exponent)
    glEnable(GL_DEPTH_TEST)





def ReSizeGLScene(Width, Height):

    if (Height==0):				# Prevent A Divide By Zero If The Window Is Too Small
	Height=1

    glViewport(0, 0, Width, Height)		# Reset The Current Viewport And Perspective Transformation

    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()

    gluPerspective(45.0,float(Width)/float(Height),0.1,100.0)
    glMatrixMode(GL_MODELVIEW)


# The main drawing function.
def DrawGLScene():

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)		# Clear The Screen And The Depth Buffer

    glLoadIdentity ();
    gluPerspective (45, 1.0, 0.01,100.0);


    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity()
    glTranslatef(0.0,0.0,zoom);
    glRotatef(-angle_y,1.0,0.0,0.0);
    glRotatef(-angle_x,0.0,1.0,0.0);


    for loop in range(len(maillage.connectivity)):
        glBegin(GL_TRIANGLES)

        X0 = maillage.geometry[maillage.connectivity[loop].index[0]]
        X1 = maillage.geometry[maillage.connectivity[loop].index[1]]
        X2 = maillage.geometry[maillage.connectivity[loop].index[2]]

        u = [X1.x[0]-X0.x[0],X1.x[1]-X0.x[1],X1.x[2]-X0.x[2]]
        v = [X2.x[0]-X0.x[0],X2.x[1]-X0.x[1],X2.x[2]-X0.x[2]]
        
        normal = [u[1]*v[2]-u[2]*v[1],u[2]*v[0]-u[0]*v[2],u[0]*v[1]-u[1]*v[0]]
        n=sqrt(normal[0]*normal[0]+normal[1]*normal[1]+normal[2]*normal[2])
        if n>=0.0001:
            for loop2 in range(2):
                normal[loop2]/=n
                

        glColor3d(0.4,0.4,0.4)
        glNormal3d(normal[0],normal[1],normal[2])

        glVertex3d(X0.x[0],X0.x[1],X0.x[2]);
        glVertex3d(X1.x[0],X1.x[1],X1.x[2]);
        glVertex3d(X2.x[0],X2.x[1],X2.x[2]);
        glEnd()


        
    # since this is double buffered, swap the buffers to display what just got drawn.
    glutSwapBuffers()
        


def keyPressed(key, x, y):

    # avoid thrashing this procedure
    time.sleep(0.1)

    if ord(key) == ESCAPE: # kill everything.
	# exit the program...normal termination. 
	sys.exit()
    else:
        print("Key %d pressed. No action there yet.\n"%(ord(key)))
    


def mouse(button,state,_x,_y):
    global presse,presse_d,xxold,yyold
    if state == GLUT_DOWN:
        xxold = _x
        yyold = _y
    if button == GLUT_LEFT_BUTTON and state == GLUT_DOWN:
        presse=1
    if button == GLUT_LEFT_BUTTON and state==GLUT_UP:
        presse=0

    if button == GLUT_RIGHT_BUTTON and state == GLUT_DOWN:
        presse_d=1
    if button == GLUT_RIGHT_BUTTON and state == GLUT_UP:
        presse_d=0

def mousemotion(_x,_y):
    global presse,presse_d,zoom,xxold,yyold,angle_x,angle_y
    if presse:
        angle_x=angle_x+(_x-xxold)
        angle_y=angle_y+(_y-yyold)
        glutPostRedisplay() 
    if presse_d:
        zoom = zoom + (_y-yyold)/50.0
        glutPostRedisplay()
    xxold=_x
    yyold=_y


def load_off_file():
    global maillage
    
    filein = open("test.off", "r")
    oneline = readstr(filein)
    while oneline[0]=='#':
        oneline=readstr(filein)
    oneline = readstr(filein).strip().split()

    N_vertex=int(oneline[0])
    N_triangle=int(oneline[1])

    for loop in range(N_vertex):
        oneline=readstr(filein).strip().split()
        maillage.geometry=maillage.geometry+[sommet(float(oneline[0]),float(oneline[1]),float(oneline[2]))]
    for loop in range(N_triangle):
        oneline=readstr(filein).strip().split()
        for loop2 in range(len(oneline)-2):
            maillage.connectivity=maillage.connectivity+[tri(int(oneline[1]),int(oneline[loop2+1]),int(oneline[loop2+2]))]




def main():
    global window
    

    #   Initialize GLUT state - glut will take any command line arguments that pertain to it or
    #   X Windows - look at its documentation at http:reality.sgi.com/mjk/spec3/spec3.html 
    glutInit(sys.argv)

    # Select type of Display mode:
    # Double buffer
    # RGBA color
    # Depth buffer
    # Alpha blending 
    glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH | GLUT_ALPHA)

    # get a 640 x 480 window 
    glutInitWindowSize(640, 480)

    # the window starts at the upper left corner of the screen 
    glutInitWindowPosition(0, 0)

    # Open a window 
    window = glutCreateWindow("\n\n[RICM3 - Polytech Visualisation-Multiresolution]\n\n")

    # Register the function to do all our OpenGL drawing. 
    glutDisplayFunc(DrawGLScene)

    # Go fullscreen.  This is as soon as possible. 
    #glutFullScreen()

    # Even if there are no events, redraw our gl scene. 
    glutIdleFunc(DrawGLScene)

    # Register the function called when our window is resized. 
    glutReshapeFunc(ReSizeGLScene)

    # Register the function called when the keyboard is pressed. 
    glutKeyboardFunc(keyPressed)

    #MOUSE
    glutMouseFunc(mouse)
    glutMotionFunc(mousemotion)



    # Initialize our window. 
    InitGL(640, 480)



    

    #load off
    load_off_file()

    # Start Event Processing Engine 
    glutMainLoop()


main()

